#!/usr/bin/python
"""
Author: Jun Ding
Date: Jan.6, 2012
Version: 1.1
Function: This code is used to get the Cis-regulatory modules for given sequences.
Usage: python crm.py <input_seq_file><support_value><p_value cutoff><output_folder_name>
"""
import sys,pdb,os,getopt,shutil
import subprocess
sys.path.append('code')
python=sys.executable
import Motif,rmRepeat
from Motif import *
from rmRepeat import *
try:
	opt,args=getopt.getopt(sys.argv[1:],"i:s:c:o:m:l:f:d")
	flag=0
	for i in opt:
		if i[0]=='-i':
			sys.argv[1]=i[1]
			flag+=1
		if i[0]=='-s':
			sys.argv[2]=i[1]
			flag+=1
		if i[0]=='-c':
			sys.argv[3]=i[1]
			flag+=1
		if i[0]=='-o':
			sys.argv[4]=i[1]
			flag+=1
		if i[0]=='-m':
			sys.argv[5]=i[1]
			flag+=1
		if i[0]=='-l':
			sys.argv[6]=i[1]
			flag+=1
		if i[0]=='-f':
			sys.argv[7]=i[1]
			flag+=1
		if i[0]=='-d':
			sys.argv[8]=i[1]
			flag+=1
	#pdb.set_trace()
	if flag>=8:
		#creat output dir- and move input seq to the output dir--------
		if os.path.exists(sys.argv[4]):
			os.system("RD /S /Q "+sys.argv[4])
		os.mkdir(sys.argv[4])
		fn=sys.argv[1].split('/')[-1]
		print(fn)
		shutil.copy2(sys.argv[1],sys.argv[4])
		#pdb.set_trace()
		#convert line format-----------------------------------------
		inputseq=sys.argv[4]+'\\'+fn
		#pdb.set_trace()
		os.system(python+ " code/remove_too_short_seq.py "+inputseq)
		os.system(python+" code/SEQProcess.py -m 3 "+inputseq)
		os.system("DEL "+inputseq)
		os.system("MOVE "+inputseq+"_LineFormat"+" "+inputseq)
		#pdb.set_trace()
		#os.system("ECHO begin scanning sequences")
		if sys.argv[5]=='default':
			sys.argv[5]="data/normalized_transfac_matrices"
		if sys.argv[6]=='default':
				sys.argv[6]="data/lambda"
		os.system(python+" code/scan.py "+inputseq+" "+sys.argv[5]+" "+sys.argv[4])
		scanout1=inputseq+"_MotifHits"
		scanout2=inputseq+"_MotifHitsPositions"
		#pdb.set_trace()
		#removing redundant motifs------------------------------------------------------------------------------
		#os.system("ECHO removing redundant motif hits...")
		os.system(python+" code/Motif.py -m 4 "+sys.argv[5]+" "+scanout1+" "+scanout2+" "+"4")
		non=scanout1+"_4_non_redundant"
		non2=scanout2+"_4_non_redundant"
		#os.remove(scanout1)
		#os.remove(scanout2)
		
		#------removing repeat hits----------------------------------------------------------------------------
		os.system(python+" code/rmRepeat.py "+non)
		nre=non+"_repeat_removed"
		#------FIM---------------------------------------------------------------------------------------------------
		#os.system("chmod +x code/fim_maximal")
		os.system("ECHO generating candidate motif modules...")
		trans=nre
		out_trans=nre+"_candidate_modules"
		#pdb.set_trace()
		os.environ["CYGWIN"]="nodosfilewarning"
		#os.system("set CYGWIN=nodosfilewarning")
		#os.system("code"+"\\"+"fim_maximal "+trans+" "+sys.argv[2]+" "+out_trans)
		subprocess.call(["code\\fim_maximal",trans,sys.argv[2],out_trans])
		#os.system("code"+"\\"+"fim_maximal "+trans+" "+sys.argv[2]+" "+out_trans)
		#pdb.set_trace()
		#------Statistical evaluation-----------------------------------------------------------------------------------------------
		os.system("echo statistical evaluation...")
		os.system(python+" code/pgc.py "+out_trans+" "+sys.argv[6]+" "+sys.argv[5]+" "+inputseq+" "+sys.argv[3])
		out_pgc=out_trans+"_significant"
		out_pgc_2=out_trans+"_corrected_pvalue"
		#pdb.set_trace()
		#-----Motif ID convertion-----------------------------------------------------------------------------------------------------------
		os.system(python+" code/sig_module_pvalue.py "+out_pgc+" "+out_pgc_2)
		
		os.system("DEL "+out_trans)
		os.system("DEL "+out_pgc_2)
		#os.system("DEL "+non)
		#os.system("DEL "+non2)
		os.remove(inputseq+"_GeneName")
		os.remove(scanout2)
		os.remove(scanout1)
		os.remove(inputseq)
		os.remove(nre)
		os.rename(out_pgc,sys.argv[4]+"/mod")
		
		#----clear all tmp files--------------------------------------------------------------------------------------------------------------------
		


	else:
		print("python crm.py \n-i <input sequence> \n-s <support value for frequent pattern mining> \n-c <pvalue cutoff> \n-o <output folder> \n-m <pwm>, 'default': Transfac PWMs, or <your PWMs file> \n-l <lambda>, 'default': default lambda used, or <your lambda file> \n-f <format>: txt,xls \n-d<want fully detailed motif combination file: Y,N>")
except:
	print("python crm.py \n-i <input sequence> \n-s <support value for frequent pattern mining> \n-c <pvalue cutoff> \n-o <output folder> \n-m <pwm>, 'default': Transfac PWMs, or <your PWMs file> \n-l <lambda>, 'default': defulat lambda used, or <your lambda file> \n-f <format>: txt,xls \n-d<want fully detailed motif combination file: Y,N")

	




